summaryrefslogtreecommitdiff
path: root/init
diff options
context:
space:
mode:
Diffstat (limited to 'init')
-rwxr-xr-xinit31
1 files changed, 31 insertions, 0 deletions
diff --git a/init b/init
new file mode 100755
index 0000000..8b6eed0
--- /dev/null
+++ b/init
@@ -0,0 +1,31 @@
+#!/bin/bash
+set -e
+
+lxc launch images:debian/buster "$1"
+USER=user
+
+EXE="lxc exec $1 -- bash -c"
+
+$EXE "useradd -m $USER"
+$EXE "groupadd nixbld"
+$EXE "usermod -a -G nixbld $USER"
+$EXE "mkdir -m 0755 /nix && chown $USER /nix"
+$EXE "apt -y install curl stterm xz-utils sudo"
+
+lxc config set "$1" security.nesting true
+lxc restart "$1"
+sleep 1
+
+UEXE="lxc exec $1 -- sudo --login --user $USER bash -ilc"
+$UEXE "curl -L https://nixos.org/nix/install | sh"
+
+$UEXE "mkdir -p /home/$USER/.config/nixpkgs/"
+lxc file push config/config.nix "$1/home/$USER/.config/nixpkgs/"
+
+$UEXE "nix-env -iA nixpkgs.myPackages"
+
+lxc file push config/nixos-config "$1/home/$USER/"
+$UEXE "nix-build '<nixpkgs/nixos>' -A vm -I."
+
+$EXE "ln -s /home/user/result/system/etc/systemd/system/* /etc/systemd/system/"
+$EXE "ln -s /home/user/result/system/etc/ssh/* /etc/ssh/"